package tools;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JPanel;

public class OldPallete extends JPanel implements MouseListener{
	private static final long serialVersionUID = -912899235510012077L;
	private final Color[] myColors=new Color[]{Color.black,Color.white,Color.lightGray,new Color(95,174,222),
			Color.MAGENTA,Color.red,Color.pink,Color.green,Color.blue,Color.orange,Color.cyan,Color.yellow,new Color(128,0,255),
			new Color(114,196,60),new Color(199,99,56),new Color(54,128,128)};
	private int positionX=50,positionY=820;
	private int width=392,height=100;
	private Color current=Color.black;
	private Brush myBrush=Brush.getInstance();
	public OldPallete(){
		this.setBounds(positionX,positionY,width,height);
		this.addMouseListener(this);
	}
	
	@Override
	public void paint(Graphics g) {
		super.paint(g);		
		for(int i=0;i<8;i++){
			g.setColor(myColors[2*i]);
			g.fillRect(i*43+48,10 ,43,35);
			g.setColor(myColors[2*i+1]);
			g.fillRect(i*43+48,55 ,43,35);
		}
		g.setColor(Color.gray);
		g.fillRect(0,0,5,120);
		for(int i=0;i<9;i++){
			g.fillRect(i*43+43,0,5,120);
		}
		g.fillRect(0, 0, width, 10);
		g.fillRect(0, height-10, width, 10);
		g.fillRect(48, height/2-5, width, 10);
		g.setColor(current);
		g.fillRect(5,10,38,height-20);
		repaint();
	}
	
	public OldPallete(int positionX, int positionY, int width, int height) {
		super();
		this.positionX = positionX;
		this.positionY = positionY;
		this.width = width;
		this.height = height;
	}


	@Override
	public void mouseClicked(MouseEvent e) {
		int x=e.getX();
		int y=e.getY();
		if(x<48){
			return;
		}
		x-=48;
		if(x%43>38){
			return;
		}
		if(y<10 || y>height-10 || (y>height/2-5 && y<height/2+5)){
			return;
		}
		int i=0;
		i=x/43;
		if(y<height/2){
			current=myColors[2*i];
		}else{
			current=myColors[2*i+1];
		}
		myBrush.setNowColor(current);
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	
}
