package tools;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

public class Pallete extends JPanel{
	private static final long serialVersionUID = -912899235510012077L;
	private final Color[] myColors=new Color[]{Color.black,Color.white,Color.lightGray,new Color(95,174,222),
			Color.MAGENTA,Color.red,Color.pink,Color.green,Color.blue,Color.orange,Color.cyan,Color.yellow,new Color(128,0,255),
			new Color(114,196,60),new Color(199,99,56),new Color(54,128,128)};
	private int positionX=50,positionY=520;
	private int width=210,height=50;
	private Color current=Color.black;
	private Brush myBrush=Brush.getInstance();
	private ColorButton buttons[],currentColor; 
	
	public Pallete(){
		this.setLayout(null);
		this.setBounds(positionX,positionY,width,height);
		buttons = new ColorButton[myColors.length];
		for (int i = 0; i < myColors.length; i++) {
			buttons[i] = new ColorButton(myColors[i]);
			buttons[i].setBackground(myColors[i]);
			buttons[i].setSize(20,20);
		}
		for (int i = 0; i < 8; i++) {
			buttons[2*i].setBounds(i*23+26,4,20,20);
			this.add(buttons[2*i]);
		}
		
		for (int i = 0; i < 8; i++) {
			buttons[2*i+1].setBounds(i*23+26,26,20,20);
			this.add(buttons[2*i+1]);
		}
		currentColor=new ColorButton(Color.black);
		currentColor.setBounds(3,4,20,40);
		currentColor.setEnabled(false);
		this.add(currentColor);
	}

	
	
	@Override
	public void paint(Graphics g) {
		currentColor.setBackground(current);
		super.paint(g);	
	}
	
	public Pallete(int positionX, int positionY, int width, int height) {
		super();
		this.positionX = positionX;
		this.positionY = positionY;
		this.width = width;
		this.height = height;
	}


	public void setCurrentColor(Color c) {
		current = c;
		currentColor.setBackground(c);
		myBrush.setNowColor(current);
	}

	class ColorButton extends JButton {
		private static final long serialVersionUID = 1L;
		private Color myColor;
		
		public ColorButton(Color c) {
			myColor=c;
			this.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					setCurrentColor(myColor);
				}
			});
		}

		public Color getMyColor() {
			return myColor;
		}

		public void setMyColor(Color myColor) {
			this.myColor = myColor;
		}
	}
}
