package ui;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import tools.Brush;
import tools.Drawer;

public class MyImage extends JPanel implements MouseListener,MouseMotionListener {
	private static final long serialVersionUID = 2609430664379802229L;
	static private Point last = null;

	private BufferedImage boom = new BufferedImage(800, 1000,BufferedImage.TYPE_INT_RGB);
	private Graphics g = boom.getGraphics();
	private Drawer type = Drawer.PEN;
	private Point first;
	private Brush myBrush=Brush.getInstance();
	private Point now = null;
	private boolean counter=false;
	private boolean drawed=false;
	public MyImage() {
		this.setBackground(Color.white);
		this.addMouseListener(this);
		this.addMouseMotionListener(this);
		g.setColor(Color.white);
		g.fillRect(0, 0, 1000,800);
	}

	public boolean isDrawed() {
		return drawed;
	}

	public void setDrawed(boolean drawed) {
		this.drawed = drawed;
	}

	public BufferedImage getBoom() {
		return boom;
	}

	public void setBoom(BufferedImage boom) {
		g=boom.getGraphics();
		this.boom = boom;
		this.drawed=false;
	}

	@Override
	public void paint(Graphics G) {
		super.paint(G);
		G.drawImage(boom, 0, 0, null);
		if(first!=null && now!=null && counter==true){
			G.setColor(myBrush.getNowColor());
			switch (type) {
			case LINE:
				G.drawLine(first.x, first.y, now.x, now.y);
				break;
			case CIRCLE:
				G.drawOval(Math.min(first.x, now.x), Math.min(first.y, now.y), Math.abs(now.x- first.x), Math.abs(now.y - first.y));
				break;
			case RECTANGLE:
				G.drawRect(Math.min(first.x, now.x), Math.min(first.y, now.y), Math.abs(now.x- first.x), Math.abs(now.y - first.y));
				break;
			}
			
		}
		repaint();
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		first = new Point(e.getX(),e.getY());
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		int x, y;
		x = e.getX();
		y = e.getY();
		type=myBrush.getNowtype();
		g.setColor(myBrush.getNowColor());
		switch (type) {
		case LINE:
			g.drawLine(first.x, first.y, x, y);
			break;
		case CIRCLE:
			g.drawOval(Math.min(first.x, x), Math.min(first.y, y), Math.abs(x- first.x), Math.abs(y - first.y));
			break;
		case RECTANGLE:
			g.drawRect(Math.min(first.x, x), Math.min(first.y, y), Math.abs(x- first.x), Math.abs(y - first.y));
			break;
		}
		drawed=true;
		last = null;
		first = null;
		counter=false;
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		type=myBrush.getNowtype();
		if (type.equals(Drawer.PEN)) {
			now = new Point(e.getX(), e.getY());
			if (last != null) {
				g.setColor(myBrush.getNowColor());
				g.drawLine(last.x, last.y, now.x, now.y);
			}
			drawed=true;
			last = now;
		}else{
			now=e.getPoint();
			repaint();
			counter=true;
		}
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		type=myBrush.getNowtype();
		if (type.equals(Drawer.PEN)) {
			this.setCursor(Toolkit.getDefaultToolkit().createCustomCursor(Toolkit.getDefaultToolkit().getImage("src/ui/pen.png"),new Point(6, 28), "MyPointer"));
		} else {
			this.setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
		}
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
	}

	@Override
	public void mouseMoved(MouseEvent arg0) {
	}

}