package ui;

import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import tools.MyFileFilter;
import tools.Pallete;

public class Window extends JFrame {
	private static final long serialVersionUID = 4891191579439256007L;
	private Pallete pallete = new Pallete();
	private MyImage myImage = new MyImage();
	private ToolBox myToolBox = new ToolBox();
	private File writeFile = null;
	private MenuBar menu = new MenuBar();
	private MyFileFilter myFilter=new MyFileFilter();
	Window() {
		this.setVisible(true);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setSize(700, 700);
		Container w = this.getContentPane();
		w.setBackground(Color.DARK_GRAY);
		this.setLayout(null);
		this.add(pallete);
		this.setTitle("Paint");
		this.add(myImage);
		this.setJMenuBar(menu);
		this.add(myToolBox);
		myImage.setBounds(0, 0, 500, 500);

	}

	public class MenuBar extends JMenuBar {
		private static final long serialVersionUID = -2335632602017660311L;
		
		JMenuItem newAction = new JMenuItem("New");
		JMenuItem saveAction = new JMenuItem("Save");
		JMenuItem saveAsAction = new JMenuItem("Save As");
		JMenuItem loadAction = new JMenuItem("Load");
		JMenuItem exitAction = new JMenuItem("Exit");
		
		public int save(){
			int x=0;
			File temp=null;
			if(myImage.isDrawed()==true){
				x = javax.swing.JOptionPane.showConfirmDialog(Window.this,"Do you want to save changes?", "save",JOptionPane.NO_OPTION);
				if(x==0){
					if(writeFile==null){
						JFileChooser chooser = new JFileChooser();
						chooser.setDialogTitle("Save");
						chooser.showSaveDialog(Window.this);
						temp = chooser.getSelectedFile();
						if(temp==null){
							return 2;	
						}
						writeFile=temp;
					}
				}else if(x==1){
					return 1;
				}else{
						if(writeFile==null){
							return x;
						}
					}				
				try {
					if(!writeFile.getName().endsWith(".bmp")){
						writeFile=new File(writeFile.getCanonicalPath()+".bmp");	
					}
					ImageIO.write(myImage.getBoom(), "bmp", writeFile);
					myImage.setDrawed(false);
				} catch (IOException e) {
				}
				myImage.setDrawed(false);
			}
			return x;
		}
	
		MenuBar() {
			JMenu fileMenu = new JMenu("File");
			fileMenu.setMnemonic('f');
			this.add(fileMenu);
			//NEW
			newAction.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					int x=save();
					if(x==1 || x==0){
						myImage.setBoom(new BufferedImage(800, 1000,BufferedImage.TYPE_INT_RGB));
						Graphics g = myImage.getBoom().getGraphics();
						g.setColor(Color.white);
						g.fillRect(0, 0, 1000, 800);
						writeFile=null;
					}
				}
			});
			
			//SAVE
			saveAction.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					save();
				}
			});
			//SAVEAS
			saveAsAction.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					boolean temp2=myImage.isDrawed();
					myImage.setDrawed(true);
					File temp=writeFile;
					writeFile=null;
					save();
					if(writeFile==null){
						writeFile=temp;
						myImage.setDrawed(temp2);
					}else{
						myImage.setDrawed(false);
					}
				}
			});
			//LOAD
			loadAction.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					File temp=null;
					if(temp==null){
						JFileChooser chooser = new JFileChooser();
						chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
						chooser.setDialogTitle("load");
						chooser.setFileFilter(myFilter);
						chooser.setAcceptAllFileFilterUsed(false);
						chooser.showOpenDialog(Window.this);
						temp = chooser.getSelectedFile();
						if(temp==null){
							return;
						}
					}
					save();
					writeFile=temp;
					try {
						BufferedImage s = ImageIO.read(writeFile);
						myImage.setBoom(s);
					} catch (IOException e) {
					}
				}
			});
			//EXIT
			exitAction.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					int x=save();
					if(x==0 || x==1){
						System.exit(0);
					}
				}
			});
			fileMenu.add(newAction);
			fileMenu.add(loadAction);
			fileMenu.add(saveAction);
			fileMenu.add(saveAsAction);
			fileMenu.addSeparator();
			fileMenu.add(exitAction);
		}
		
	}

//	@Override
	public void paint(Graphics g) {
		super.paint(g);
	}

	public static void main(String[] args) {
		new Window();
	}
}
	